/* /////////////////////////////////////////////////////////////////////////////////////////////////

Author: PluginIdea
Email:sugamer8 @gmail.com
 Patreon:https://www.patreon.com/PluginIdea

©2022 PluginIdea, Inc.All rights reserved.

///////////////////////////////////////////////////////////////////////////////////////////////// */

using UnityEngine;using System.Collections.Generic;using Battlehub.RTCommon;namespace PluginIdea{    public class HairHandle : MVRScript    {        private JSONStorableBool isWorldSpace;        private JSONStorableBool isLockPosX;        private JSONStorableBool isLockPosY;        private JSONStorableBool isLockPosZ;        private JSONStorableBool isLockRotX;        private JSONStorableBool isLockRotY;        private JSONStorableBool isLockRotZ;        private List<FreeControllerV3> hairTools = new List<FreeControllerV3>();        private int index = 0;        private bool isShowAxis = true;        public override void Init()        {            base.Init();            UIInit();            Transform rescaleObj = containingAtom.reParentObject.Find("object/rescaleObject");            for (int i = 0; i < 4; i++)            {                Transform hairTool = rescaleObj.Find(string.Format("hairTool{0}", i + 1));                if (hairTool != null)                {                    hairTools.Add(hairTool.GetComponent<FreeControllerV3>());                }            }            FreeControllerV3 scapMask = rescaleObj.Find("hairScalpMaskTool").GetComponent<FreeControllerV3>();            hairTools.Add(scapMask);            SuperController.singleton.BroadcastMessage("OnActionsProviderAvailable", this, SendMessageOptions.DontRequireReceiver);        }        private void UIInit()        {            Utils.OnInitUI(CreateUIElement);            Utils.SetupInfoText(this, Location.GetStr(Location.PluginInfo), 300, true);            isWorldSpace = Utils.SetupToggle(this, Location.GetStr(Location.IsWorldSpace), false, false);            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.LockPositionSubtitle), 35, false);            isLockPosX = Utils.SetupToggle(this, Location.GetStr(Location.LockPositionX), false, false);            isLockPosY = Utils.SetupToggle(this, Location.GetStr(Location.LockPositionY), false, false);            isLockPosZ = Utils.SetupToggle(this, Location.GetStr(Location.LockPositionZ), false, false);            Utils.SetupInfoTextNoScroll(this, Location.GetStr(Location.LockRotationSubtitle), 35, false);            isLockRotX = Utils.SetupToggle(this, Location.GetStr(Location.LockRotationX), false, false);            isLockRotY = Utils.SetupToggle(this, Location.GetStr(Location.LockRotationY), false, false);            isLockRotZ = Utils.SetupToggle(this, Location.GetStr(Location.LockRotationZ), false, false);        }        private bool IsHandlesEnable        {            get            {                SuperController sc = SuperController.singleton;                UserPreferences up = UserPreferences.singleton;                bool handlesEnabled = isShowAxis && sc.MonitorCenterCamera != null && (!up.showTargetsMenuOnly || sc.mainHUD.gameObject.activeSelf);                return handlesEnabled;            }        }        private void ShowRotateHandleView()        {            FCRotationHandle rotationHandle = SuperController.singleton.selectedControllerRotationHandle;            rotationHandle.controller = hairTools[index];            if (rotationHandle != null)            {                rotationHandle.enabled = IsHandlesEnable;                rotationHandle.controller.xRotLock = isLockRotX.val;                rotationHandle.controller.yRotLock = isLockRotY.val;                rotationHandle.controller.zRotLock = isLockRotZ.val;            }        }        private void ShowPositionHandleView()        {            FCPositionHandle positionHandle = SuperController.singleton.selectedControllerPositionHandle;            positionHandle.controller = hairTools[index];            if (positionHandle != null)            {                positionHandle.enabled = IsHandlesEnable;                if (!isWorldSpace.val)                {                    positionHandle.controller.xLocalLock = isLockPosX.val;                    positionHandle.controller.yLocalLock = isLockPosY.val;                    positionHandle.controller.zLocalLock = isLockPosZ.val;                }                else                {                    positionHandle.controller.xLock = isLockPosX.val;                    positionHandle.controller.yLock = isLockPosY.val;                    positionHandle.controller.zLock = isLockPosZ.val;                }            }        }        private void Update()        {            RuntimeTools.PivotRotation = isWorldSpace.val ? RuntimePivotRotation.Global : RuntimePivotRotation.Local;            if (Input.GetKeyDown(KeyCode.J))            {                SelectNextBrush();            }            if (Input.GetKeyDown(KeyCode.H))            {                ShowHideAxis();            }            if (Input.GetKeyDown(KeyCode.K))            {                ResetRotation();            }            ShowRotateHandleView();            ShowPositionHandleView();        }        private void ResetRotation()        {            var selectedController = hairTools[index];            if (selectedController != null)            {                selectedController.transform.rotation = Quaternion.identity;            }        }        private void ShowHideAxis()        {            isShowAxis = !isShowAxis;        }        private void SelectNextBrush()        {            index++;            if (index > hairTools.Count - 1)                index = 0;            SyncUI();        }        private void SyncUI()        {            var v3 = hairTools[index];            if (v3 != null)            {                if (isWorldSpace.val)                {                    isLockPosX.val = v3.xLock;                    isLockPosY.val = v3.yLock;                    isLockPosZ.val = v3.zLock;                }                else                {                    isLockPosX.val = v3.xLocalLock;                    isLockPosY.val = v3.yLocalLock;                    isLockPosZ.val = v3.zLocalLock;                }                isLockRotX.val = v3.xRotLock;                isLockRotY.val = v3.yRotLock;                isLockRotZ.val = v3.zRotLock;            }        }        public void OnBindingsListRequested(List<object> bindings)        {            bindings.Add(new JSONStorableAction("Select NextBrush", SelectNextBrush));            bindings.Add(new JSONStorableAction("ShowHide Axis", ShowHideAxis));            bindings.Add(new JSONStorableAction("Reset Rotation", ResetRotation));        }        private void OnDestroy()        {            SuperController.singleton.BroadcastMessage("OnActionsProviderDestroyed", this, SendMessageOptions.DontRequireReceiver);            Utils.OnDestroyUI();        }    }}